#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "include/banshee.h"
#include "include/version.h"

/* Externs */

FILE *scanfp;
struct sflags flags;

void *handler(int);
void *fhandler(int);

int main(int argc, char *argv[]) {


extern FILE *scanfp;
extern struct sflags flags;

	/* Getopt vars */

int opt;
extern char *optarg;
char *optopts = "p:m:i:e:d:b:vMrsS";

	/* Parsing and flag vars */

char *maskas = NULL;
char *iplist = NULL;
int massflag = 0;
int stdlist = 0;
unsigned int lport, hport, curport;
int statflag = 0;

	/* Other vars used in main.c */

FILE *fp;
FILE *stat;
char ipbuf[128];
char *ips = NULL;
char dirbuf[128];
char *tmpptr = NULL;


	/* Init flags */

lport = 1;
hport = 1024;

flags.rpcflag = 0;
flags.exeflag = 0;
flags.banflag = 0;
flags.banmax = 0;
flags.timeout = 5 + 30;
strncpy(flags.logdir,"./",128);

if(argc < 2) 
usage(argv[0]);
					   /* make sure we
                                              close and flush files */

while(flags.timeout-- > 5) 
signal(flags.timeout-5,(void *)fhandler);
signal(SIGALRM,(void *)handler);


while((opt = getopt(argc,argv,optopts)) != EOF) {

	switch(opt) {

		case 'm': {
		 maskas = optarg;
		 break; }

		case 'M': {
		 massflag = 1;
		 break; }
	
		case 'r': {
		 flags.rpcflag = 1;
		 break; }

		case 'd': {
		 strncpy(flags.logdir,optarg,128);
		 break; }
		 

		case 'e': {
		 flags.exeflag = 1;
		 flags.exefile = optarg;
		 break; }

		case 'p': {

		 if((strchr(optarg,'-')) == NULL) {
		 lport = atoi(optarg);
		 hport = (atoi(optarg) +1); }

		  else {

		   lport = atoi(strtok(optarg,"-"));
		   hport = atoi(strtok(NULL,"-")); }

		   if(lport < 1 || lport > 65535) {
		    printf("Invalid Port range\n");
		    exit(1); }
		
		   if(hport < 1 || hport > 65535) {
		    printf("Invalid Port range\n");
		    exit(1); }

		break; }

		case 'i': {
		 iplist = optarg;
		 break; }

		case 'S': {
		 stdlist = 1;
		 break; }
	       
                case 's': {
		 statflag = 1;
		 break; }

		case 'b': {

		flags.banflag = 1;

		if((tmpptr = strtok(optarg,",")) == NULL) {
		printf("Bad bannerports\n");
		exit(0); }

		flags.banbuf[0] = atoi(tmpptr);

		for(flags.banmax = 1;;flags.banmax++) {
		
		  if((tmpptr = strtok(NULL,",")) == NULL)
		   break;

		flags.banbuf[flags.banmax] = atoi(tmpptr);

		 if(flags.banbuf[flags.banmax] < flags.banbuf[flags.banmax-1]) {
		  printf("Banner ports must be in ascending order\n");
		  exit(0); }
                             }

		break; }

		case 't': {
		 flags.timeout = atoi(optarg);
		 break; }

		case 'v': {
		 printf("%s-%s\n",argv[0],VERSION);
		 exit(0);
		 break; }

	}
    }


if(maskas != NULL)		/* Proc masking */
mask(argc,argv,maskas);

if(flags.banflag)		/* Banner grabbing */
baninit();

if(statflag) {
if((stat = fdopen(0,"w")) == NULL)
bail("fdopen()"); }

else {
snprintf(dirbuf,sizeof(dirbuf),"%s/%s",flags.logdir,STATLOG);
if((stat = fopen(dirbuf,"w")) == NULL)
bail("fopen()"); }
				/* Status header */


fprintf(stat,"Banshee-%s - Phish@mindless.com\n\n",VERSION);

if(massflag)
fprintf(stat,"\tMassmode: Activated\n");

fprintf(stat,"\tLogdir: %s\n",flags.logdir);
fprintf(stat,"\tPortrange: %d-%d\n",lport,hport);
fprintf(stat,"\tTimeout: %d\n",flags.timeout);

if(iplist != NULL)
fprintf(stat,"\tInput: %s\n",iplist);
if(stdlist)
fprintf(stat,"\tInput: stdin\n");
if(flags.rpcflag)
fprintf(stat,"\tRpcscanning: Activated\n");
if(flags.exeflag)
fprintf(stat,"\tEnv Exe: %s\n",flags.exefile);
if(flags.banflag) {
fprintf(stat,"\tBanner logging: ");
for(opt = 0; opt < flags.banmax;opt++)
fprintf(stat,"%d ",flags.banbuf[opt]);
fprintf(stat,"\n"); }
fprintf(stat,"\n\n");


if(stdlist) {					/* stdin list */
if((fp = fdopen(0,"r")) == NULL)
bail("fopen()"); }

else if(iplist != NULL) {
if((fp = fopen(iplist,"r")) == NULL)		/* Iplist */
bail("fopen()"); }

else {
fprintf(stderr,"Error: -i or -S is required\n");
exit(1); }

snprintf(dirbuf,sizeof(dirbuf),"%s/%s",flags.logdir,PORTLOG);
if((scanfp = fopen(dirbuf,"a")) == NULL)	/* Portscan log */
bail("fopen()");	

while((fgets(ipbuf,sizeof(ipbuf),fp)) != NULL) {

fprintf(stat,"%s",ipbuf);
fflush(scanfp);
fflush(stat);

if((ips = strtok(ipbuf,"\n")) == NULL)
break;

if(massflag) {

if((opt = fork()) == -1)
bail("fork()");

if(!opt) {

alarm(flags.timeout*10);

for(curport=lport;curport < hport;curport++)
scan(ips,curport);

fprintf(scanfp,"\n");

if(flags.rpcflag)       /* rpc scanning */
rpc(ipbuf);

if(flags.exeflag) {     /* env exe */

  setenv(ENVVAR,ipbuf,1);
  chmod(flags.exefile,S_IXUSR);
  system(flags.exefile); }

alarm(0);
exit(0); }
          }
  
else  {


for(curport=lport;curport < hport;curport++)
scan(ips,curport);

fprintf(scanfp,"\n");

if(flags.rpcflag)       /* rpc scanning */
rpc(ipbuf);

if(flags.exeflag) {     /* env exe */

  setenv(ENVVAR,ipbuf,1);
  chmod(flags.exefile,S_IXUSR);
  system(flags.exefile);
  unsetenv(ENVVAR); }

}
 }

			/* De-init */

fprintf(stat,"\n\n");
fcloseall();
return 0; }

void *handler(int dum) {

exit(0);
return NULL;

}				/* stoooopid handlers */

void *fhandler(int dum) {

fcloseall();
return NULL;

}
